package asd.td3;

/**
 * Une classe pour l'exercice 6 de la feuille 3.
 * On crit rcursivement toutes les permutations d'ordre donn.
 *  2002 Marc Gatano
 */
public class Permutation {

    /**
     * Construit un objet Permutation.
     */
    public Permutation() {
    }

    /**
     * Imprime toutes les permutations de (1,2,...,n) sur le
     * flux de sortie.
     * Complexit : O(n!).
     */
    public void imprimer(int n) {
        int[] p = new int[n];

        for( int i = 0; i < p.length; i++ ) {
            p[i] = i+1;
        }
        imprimer(p,0);
    }

    /**
     * Permute de toutes les faons possibles p[i..p.length-1] et imprime p
     * pour chacune de ces permutations.
     * ATTENTION : cette mthode laisse p inchang !.
     * Complexit : O(k!) o k = p.length - i.
     */
    private void imprimer(int[] p, int i) {
        if ( i == p.length-1 ) {
            imprimer(p);
        }
        else {
            for( int k = i; k < p.length; k++ ) {
                int x = p[i];
                p[i] = p[k];
                p[k] = x;
                imprimer(p,i+1);
            }
            int x = p[i];
            for( int k = i+1; k < p.length; k++ ) {
                p[k-1] = p[k];
            }
            p[p.length-1] = x;
        }
    }

    /**
     * Imprime le contenu du tableau p sur le flux de sortie.
     * Complexit : O(p.length).
     */
    private void imprimer(int[] p) {
        System.out.print('(');
        System.out.print(p[0]);
        for( int i = 1; i < p.length; i++ ) {
            System.out.print(", " + p[i]);
        }
        System.out.println(')');
    }
}
